package MT::Plugin::PreviousNextInCategory;

use strict;
use warnings;
use base qw( MT::Plugin );

use MT;
use MT::Template::Context;

our $VERSION = '0.02';
my $plugin = MT::Plugin::PreviousNextInCategory->new({
    id          =>  'PreviousNextInCategory',
    name        =>  'PreviousNextInCategory',
    description =>  'PreviousNextInCategory',
    version     => $VERSION,
    author_name => 'Six Apart, Ltd.',
    author_link => 'http://www.sixapart.com/',
});
MT->add_plugin($plugin);
MT::Template::Context->add_container_tag('EntryPreviousInCategory' => \&_hdlr_entry_previous_in_category);
MT::Template::Context->add_container_tag('EntryNextInCategory' => \&_hdlr_entry_next_in_category);

MT->add_callback('MT::App::CMS::CMSPostSave.entry', 10, $plugin,
                  sub { $plugin->runner('_rebuild', @_) } );
sub _rebuild {
    my $plugin = shift;
    my ($eh, $app, $entry) = @_;
    my $cats = $entry->categories;
    for my $cat (@$cats) {
        my $prev = $entry->previous(1);
        while ($prev && !$prev->is_in_category($cat)) {
            $prev = $prev->previous(1);
        }
        $app->rebuild_entry(Entry => $prev->id) if $prev;
        my $next = $entry->next(1);
        while ($next && !$next->is_in_category($cat)) {
            $next = $next->next(1);
        }
        $app->rebuild_entry(Entry => $next->id) if $next;
    }
    return 1;
}
sub runner {
    my $plugin = shift;
    my $method = shift;
    return $_->($plugin, @_) if $_ = \&{"$method"};
}

# vOC_hdlr_entry_previous_in_category(7sځ`32s)ɓ\tāA̍s폜

# vOC_hdlr_entry_next_in_category(33sځ`59s)ɓ\tāA̍s폜

# ӁFL2ȊO̍s͈ؕύXȂłi̍s͎cĂ폜Ăǂł܂܂jB

1;
